=== modified file 'source/braille.py'
--- source/braille.py	2012-02-24 06:53:06 +0000
+++ source/braille.py	2012-04-14 15:33:21 +0000
@@ -258,7 +258,7 @@
 }
 negativeStateLabels = {
 	# Translators: Displayed in braille when an object (e.g. a check box) is not checked.
-	controlTypes.STATE_CHECKED: _("( )"),
+	#controlTypes.STATE_CHECKED: _("( )"),
 }
 
 DOT7 = 64
@@ -420,7 +420,7 @@
 		positiveStates = controlTypes.processPositiveStates(role, states, controlTypes.REASON_FOCUS, states)
 		textList.extend(positiveStateLabels.get(state, controlTypes.stateLabels[state]) for state in positiveStates)
 		negativeStates = controlTypes.processNegativeStates(role, states, controlTypes.REASON_FOCUS, None)
-		textList.extend(negativeStateLabels.get(state, _("not %s") % controlTypes.stateLabels[state]) for state in negativeStates)
+		textList.extend(negativeStateLabels.get(state, controlTypes.negativeStateLabels.get(state, _("not %s") % controlTypes.stateLabels[state])) for state in negativeStates)
 	if roleText:
 		textList.append(roleText)
 	description = propertyValues.get("description")

=== modified file 'source/controlTypes.py'
--- source/controlTypes.py	2012-01-04 07:53:24 +0000
+++ source/controlTypes.py	2012-04-14 15:43:51 +0000
@@ -365,6 +365,13 @@
 	STATE_SORTED_DESCENDING:_("sorted descending"),
 }
 
+negativeStateLabels={
+	STATE_FOCUSED:_("not focused"),
+	STATE_SELECTED:_("not selected"),
+	STATE_PRESSED:_("not pressed"),
+	STATE_CHECKED:_("not checked"),
+}
+
 silentRolesOnFocus={
 	ROLE_PANE,
 	ROLE_ROOTPANE,

=== modified file 'source/speech.py'
--- source/speech.py	2012-02-22 02:58:10 +0000
+++ source/speech.py	2012-04-14 15:11:26 +0000
@@ -787,7 +787,7 @@
 			# "not drop target" doesn't make any sense, so use a custom message.
 			textList.append(_("done dragging"))
 			negativeStates.discard(controlTypes.STATE_DROPTARGET)
-		textList.extend([_("not %s")%controlTypes.stateLabels[x] for x in negativeStates])
+		textList.extend([controlTypes.negativeStateLabels.get(x, _("not %s")%controlTypes.stateLabels[x]) for x in negativeStates])
 	if 'description' in propertyValues:
 		textList.append(propertyValues['description'])
 	if 'keyboardShortcut' in propertyValues:
@@ -892,9 +892,9 @@
 
 	# Determine the order of speech.
 	# speakContentFirst: Speak the content before the control field info.
-	speakContentFirst = reason == controlTypes.REASON_FOCUS and presCat != attrs.PRESCAT_CONTAINER and role not in (controlTypes.ROLE_EDITABLETEXT, controlTypes.ROLE_COMBOBOX) and not tableID and controlTypes.STATE_EDITABLE not in states
+	speakContentFirst = reason == controlTypes.REASON_FOCUS and presCat != attrs.PRESCAT_CONTAINER and role not in (controlTypes.ROLE_EDITABLETEXT, controlTypes.ROLE_COMBOBOX, controlTypes.ROLE_TABLECELL) and not tableID and controlTypes.STATE_EDITABLE not in states
 	# speakStatesFirst: Speak the states before the role.
-	speakStatesFirst=role==controlTypes.ROLE_LINK
+	speakStatesFirst=role in [controlTypes.ROLE_LINK, controlTypes.ROLE_TABLECELL]
 
 	# Determine what text to speak.
 	# Special cases
@@ -1048,6 +1048,7 @@
 		if (link or oldLink is not None) and link!=oldLink:
 			text=_("link") if link else _("out of %s")%_("link")
 			textList.append(text)
+			tones.beep(2500,50)
 	if  formatConfig["reportComments"]:
 		comment=attrs.get("comment")
 		oldComment=attrsCache.get("comment") if attrsCache is not None else None

